src/config/urls.py
from django.contrib import admin
from django.urls import path, include

from students.views import IndexView, PageNotFoundView

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("admin/", admin.site.urls),
    path("groups/", include("groups.urls")),
    path("students/", include("students.urls")),
    path("teachers/", include("teachers.urls")),
    path("", IndexView.as_view(), name="index"),
    path("oauth/", include("social_django.urls", namespace="social")),
]


handler404 = PageNotFoundView.as_view()

src/groups/urls.py
from django.urls import path

from groups.views import (
    GetGroupsView,
    CreateGroupView,
    UpdateGroupView,
    DeleteGroupView,
)

app_name = "groups"

urlpatterns = [
    path("", GetGroupsView.as_view(), name="get_groups"),
    path("create/", CreateGroupView.as_view(), name="create_group"),
    path("update/<uuid:pk>/", UpdateGroupView.as_view(), name="update_group"),
    path("delete/<uuid:pk>/", DeleteGroupView.as_view(), name="delete_group"),
]

src/groups/models.py
import random
import uuid

from django.db import models
from faker import Faker


class Group(models.Model):
    id = models.UUIDField(
        primary_key=True, unique=True, editable=False, default=uuid.uuid4
    )
    group_name = models.CharField(max_length=128)
    curator = models.CharField(max_length=128, null=True)
    max_number_of_students = models.SmallIntegerField(default=0, null=True)
    budget_places_quota = models.SmallIntegerField(default=0, null=True)
    admission_year = models.DateField(null=True)
    graduation_year = models.DateField(null=True)

    def __str__(self):
        return f"{self.group_name}"

    @classmethod
    def generate_instances(cls, count):
        faker = Faker()
        for _ in range(count):
            cls.objects.create(
                group_name=faker.word(),
                curator=faker.name(),
                max_number_of_students=random.randint(20, 30),
                budget_places_quota=random.randrange(50, 80, 5),
                admission_year=faker.date_between(start_date="-5y"),
                graduation_year=faker.date_between(start_date="today", end_date="+5y"),
            )

src/groups/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from django.views.generic import ListView, CreateView, UpdateView, DeleteView

from groups.models import Group


class GetGroupsView(LoginRequiredMixin, ListView):
    login_url = reverse_lazy("students:user_login")
    template_name = "groups-list.html"
    model = Group


class CreateGroupView(LoginRequiredMixin, CreateView):
    login_url = reverse_lazy("students:user_login")
    template_name = "groups-create.html"
    http_method_names = ["get", "post"]
    model = Group
    fields = "__all__"
    success_url = reverse_lazy("groups:get_groups")


class UpdateGroupView(LoginRequiredMixin, UpdateView):
    login_url = reverse_lazy("students:user_login")
    template_name = "groups-edit.html"
    http_method_names = ["get", "post"]
    model = Group
    fields = "__all__"
    success_url = reverse_lazy("groups:get_groups")


class DeleteGroupView(LoginRequiredMixin, DeleteView):
    login_url = reverse_lazy("students:user_login")
    template_name = "groups_confirm_delete.html"
    http_method_names = ["get", "post"]
    model = Group
    success_url = reverse_lazy("groups:get_groups")

src/groups/templates/groups-create.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method="POST">
        {% csrf_token %}
        <p>New group</p>
        <br>
        {{ form|crispy }}
        <br>
        <p>
            <button type="submit" value="Create" class="btn btn-success">Create</button>
        </p>
    </form>
{% endblock %}

src/groups/templates/groups-edit.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method="POST">
        {% csrf_token %}
        <p>Edit group</p>
        <br>
        {{ form|crispy }}
        <br>
        <p>
            <button type="submit" value="Create" class="btn btn-success">Update</button>
        </p>
    </form>
{% endblock %}

src/groups/templates/groups-list.html
{% extends "index.html" %}

{% block content %}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">Name</th>
            <th scope="col">Admission year</th>
            <th scope="col">Graduation year</th>
            <th scope="col">Edit</th>
            <th scope="col">Delete</th>
        </tr>
        </thead>
        <tbody>
        {% for group in object_list %}
            <tr>
                <td>{{ group.group_name }}</td>
                <td>{{ group.admission_year }}</td>
                <td>{{ group.graduation_year }}</td>
                <td><a type="button" class="btn btn-warning"
                       href="{% url "groups:update_group" group.id %}">Edit</a></td>
                <td><a type="button" class="btn btn-danger"
                       href="{% url "groups:delete_group" group.id %}">Delete</a></td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

src/groups/templates/groups_confirm_delete.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <div>
        <form method="post">{% csrf_token %}
            <p>Are you sure you want to delete "{{ object }} group"?</p>
            {{ form|crispy }}
            <input type="submit" value="Confirm">
        </form>
    </div>
{% endblock %}